=== debian/changelog ===
lammps (20231121+dfsg-4) unstable; urgency=medium

  * Team upload.
  * python3-lammps Depends: liblammps-dev not liblammps0
    since loads liblammps.so using CDLL (ctypes dlopen)

 -- Drew Parsons <dparsons@debian.org>  Sun, 31 Dec 2023 10:32:04 +0100

lammps (20231121+dfsg-3) unstable; urgency=medium

  * Team upload.
  * libpnetcdf-dev is supported only on 64-bit systems
    [amd64 arm64 mips64el ppc64el riscv64 s390x ia64 ppc64 sparc64]
    For loong64 support see Bug#1058578.

 -- Drew Parsons <dparsons@debian.org>  Sat, 30 Dec 2023 13:44:33 +0100

lammps (20231121+dfsg-2) unstable; urgency=medium

  * Team upload.
  * move python3-sphinx to general Build-Depends to allow
    dh --with sphinxdoc to work in arch builds.

 -- Drew Parsons <dparsons@debian.org>  Sat, 30 Dec 2023 12:29:18 +0100

lammps (20231121+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream Feature Release 21 Nov 2023.
    - html docs provides in upstream tarball, no need to rebuild
  * create debian/watch monitoring the list of releases in
    machine-readable format at
    https://download.lammps.org/tars/releases/
    (linked as "older versions" from
    https://www.lammps.org/download.html)
  * drop debian patch 10_enable_spglib.patch: spglib support is now
    managed by cmake
  * update debian patch 20_set_potentials_path.patch to keep reading
    env variable LAMMPS_POTENTIALS as used in upstream code for custom
    potential data sets. Use the default debian location
    /usr/share/lammps/potentials if LAMMPS_POTENTIALS is not defined.
  * use pybuild to build python module after library. Closes: #1054792.
    - Build-Depends: pybuild-plugin-pyproject
    - test using example demo.py (build time and debian/tests runtime)
    - drop debian/python3-lammps.install
  * install benchmarks in lammps-examples (/usr/share/lammps/bench)
    - update debian patch do-not-install-potentials.patch to keep cmake
      from installing bench files in order to enable arch-indep builds
      (dh_install installs them from the source dir)
  * update debian/copyright
    - src/USER* dirs renamed
    - lib/message/cslib no longer used
  * remove generated python files. Closes: #1048351.
  * update docs in lammps-doc
    - rebuild HTML docs using sphinx. Closes: #988849.
    - dh --with sphinxdoc and Build-Depends: libjs-sphinxdoc
      - neverthless skip dh_sphinxdoc since sphinx and dh_sphinx are
        broken for lammps docs. See Bug#1059621
    - Build-Depends-Indep: python3-venc not virtualvenv,
      python3-sphinxcontrib.jquery
    - move existing upstream html to html.org. Closes: #1049827.
    - update debian patch 30_build_docs.patch
      - skip sphinxfortran (not available for debian)
      - use local mathjax. Build-Depends: libjs-mathjax
        (config=TeX-AMS-MML_HTMLorMML not MML_CHTML)
    - provide Manual.pdf in lammps-doc
    - register html and PDF docs with doc-base
    - override lintian warning source-is-missing [doc/html/*.html]
      Source is in doc/src.
    - override dh_compress to not compress pdf files
  * update build config options: use PKG_* instead of PKG_USER_*
    Activate DIELECTRIC. Closes: #1050795.
  * Build-Depends: libpnetcdf-dev (as well as libnetcdf-dev)
    Lammps supports parallel NETCDF, though not parallel HDF5 (H5MD)

 -- Drew Parsons <dparsons@debian.org>  Sat, 30 Dec 2023 10:45:36 +0100
